//working code made by Brian Brocken (bribro12) for Subby the interactive robot
//tested on 19-04-2019
//improvements in comparison with last version: number of programms isn't limited to 9 anymore, programs get chosen randomly, programs get chosen with intigers instead of strings, more little programss added

#include <Servo.h>

Servo Servo1; // Right arm elbow || greater than 90 is opening arm
Servo Servo2; // Rigth arm shoulder up/down || greater than 90 is opening arm
Servo Servo3; // Rigth arm schoulder rotation || greater than 90 is rotating backwards
Servo Servo4; // Left arm elbow || smaller than 90 is opening arm
Servo Servo5; // Left arm shoulder up/down || smaller than 90 is opening arm
Servo Servo6; // Left arm shoulder rotation || smaller than 90 is rotating backwards
Servo Servo7; // Head rotate left/right || greater than 90 is looking left (from the robot his standpoint)
Servo Servo8; // Head rotate up/down || greater than 90 is looking down (max val = 70, 100)
 
int Val1 = 3000;
int Val2 = 1000;
int Val3 = 500;
int Val4 = 125;
int Val5 = 250;
int Val6 = 50;

int randNumber;

String Counter;
int LED = 11;
int Relay = 10;
int StringLength;
String OldValue;

void setup() {

  Serial.begin(9600);
  pinMode(LED, OUTPUT);
  pinMode(Relay, OUTPUT);

  Servo1.attach(2);
  Servo2.attach(3);
  Servo3.attach(4);
  Servo4.attach(5);
  Servo5.attach(6);
  Servo6.attach(7);
  Servo7.attach(8);
  Servo8.attach(9);

  restpos();
}

void loop() {
 
  while (Serial.available()) {

    Counter= Serial.readString(); //reads the string from the serial communication with the VB app.
    StringLength = Counter.length();
    Counter.remove(0, StringLength - 1); //only takes the last number from the string.

    if (Counter != OldValue){
       OldValue = Counter;
       randNumber = random(0, 13); //if the vallue from the string changes, chose a random number from 0 to 12 (not 13)
    

    if (randNumber == 0){
    startup();
    // strong man
    Servo1.write(60);
    Servo2.write(90);
    Servo3.write(165);
    Servo4.write(120);
    Servo5.write(80);
    Servo6.write(10);
    Servo7.write(60);
    Servo8.write(70);
    delay(Val1);
    restpos();
    
    }

    if (randNumber == 1){
    startup();  
    // Everything centered
    Servo1.write(135);
    Servo2.write(110);
    Servo3.write(70);
    Servo4.write(50);
    Servo5.write(60);
    Servo6.write(80);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val2);
    // arms and head rotating left and right
    Servo3.write(0);
    Servo6.write(10);
    Servo7.write(55);
    delay(Val2);
    Servo3.write(170);
    Servo6.write(180);
    Servo7.write(120);
    delay(Val2);
    Servo3.write(70);
    Servo6.write(80);
    Servo7.write(90);
    delay(Val2);
    Servo1.write(70);
    Servo2.write(70);
    Servo4.write(110);
    Servo5.write(105);
    delay(Val4);
    restpos();
    }

    if (randNumber == 2){
    startup();
    // Standing proud
    Servo1.write(60);
    Servo2.write(35);
    Servo3.write(1);
    Servo4.write(120);
    Servo5.write(150);
    Servo6.write(175);
    Servo7.write(60);
    Servo8.write(70);
    delay(Val1);
    restpos();
    }

    if (randNumber == 3){
    startup();  
    // The usain
    Servo1.write(45);
    Servo2.write(70);
    Servo3.write(165);
    Servo4.write(50);
    Servo5.write(100);
    Servo6.write(10);
    Servo7.write(150);
    Servo8.write(70);
    delay(Val1);
    restpos();
    }

    if (randNumber == 4){
    startup();  
    // strong man 2
    Servo1.write(60);
    Servo2.write(30);
    Servo3.write(30);
    Servo4.write(120);
    Servo5.write(160);
    Servo6.write(130);
    Servo7.write(90);
    Servo8.write(95);
    delay(Val1);
    restpos();
    }

    if (randNumber == 5){
    startup();  
    // arm wave
    Servo1.write(135);
    Servo2.write(110);
    Servo3.write(1);
    Servo4.write(50);
    Servo5.write(60);
    Servo6.write(175);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val3);
    Servo7.write(150);
    delay(Val3);
    Servo4.write(0);
    delay(Val4);
    Servo5.write(20);
    delay(Val4);
    Servo4.write(150);
    Servo1.write(50);
    delay(Val4);
    Servo7.write(30);
    Servo5.write(60);
    Servo2.write(150);
    delay(Val4);
    Servo4.write(50);
    Servo1.write(180);
    delay(Val4);
    Servo2.write(110);
    delay(Val4);
    Servo1.write(135);
    delay(Val3);
    Servo7.write(90);
    delay(Val3);
    Servo1.write(70);
    Servo4.write(110);
    delay(Val4);
    restpos();
    }

    if (randNumber == 6){
    startup();
    // because of you
    Servo1.write(135);
    Servo2.write(20);
    Servo3.write(75);
    Servo4.write(120);
    Servo5.write(150);
    Servo6.write(175);
    Servo7.write(90);
    Servo8.write(70);
    delay(Val3);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val2);
    restpos();
    }

    if (randNumber == 7){
    startup();
    //robot dance
    Servo1.write(135);
    Servo2.write(110);
    Servo3.write(70);
    Servo4.write(50);
    Servo5.write(60);
    Servo6.write(80);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val2);
    Servo1.write(45);
    Servo4.write(150);
    delay(Val2);
    Servo3.write(1);
    Servo6.write(175);
    delay(Val2);
    Servo7.write(10);
    Servo8.write(95);
    delay(Val2);
    Servo1.write(100);
    delay(Val3);
    Servo1.write(45);
    delay(Val3);
    Servo1.write(100);
    delay(Val3);
    Servo1.write(45);
    delay(Val2);
    Servo7.write(160);
    delay(Val3);
    Servo4.write(105);
    delay(Val3);
    Servo4.write(150);
    delay(Val3);
    Servo4.write(105);
    delay(Val3);
    Servo4.write(150);
    delay(Val3);
    Servo7.write(90);
    delay(Val2);
    restpos();
    }

    if (randNumber == 8){
    startup();
    // Salute
    Servo1.write(80);
    Servo2.write(20);
    Servo3.write(145);
    Servo4.write(120);
    Servo5.write(150);
    Servo6.write(175);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val2);
    Servo3.write(110);
    Servo1.write(110);
    delay(Val2);
    Servo1.write(60);
    Servo2.write(35);
    Servo3.write(1);
    delay(Val1);
    restpos();
    }

    if (randNumber == 9){
    startup();
    // happy
    Servo1.write(45);
    Servo2.write(100);
    Servo3.write(160);
    Servo4.write(150);
    Servo5.write(70);
    Servo6.write(10);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val3);
    Servo1.write(120);
    Servo2.write(30);
    Servo8.write(70);
    delay(Val3);
    Servo1.write(45);
    Servo2.write(100);
    Servo4.write(50);
    Servo5.write(160);
    Servo8.write(95);
    delay(Val3);
    Servo1.write(120);
    Servo2.write(30);
    Servo4.write(150);
    Servo5.write(70);
    Servo8.write(70);
    delay(Val3);
    Servo1.write(45);
    Servo2.write(100);
    Servo4.write(50);
    Servo5.write(160);
    Servo8.write(95);
    delay(Val3);
    Servo1.write(120);
    Servo2.write(30);
    Servo4.write(150);
    Servo5.write(70);
    Servo8.write(70);
    delay(Val3);
    Servo1.write(45);
    Servo2.write(100);
    Servo3.write(160);
    Servo4.write(150);
    Servo5.write(70);
    Servo6.write(10);
    Servo7.write(90);
    Servo8.write(80);
    delay(Val2);
    restpos();
    }

    if (randNumber == 10){
    startup();
    //Body builder
    Servo1.write(60);
    Servo2.write(90);
    Servo3.write(165);
    Servo4.write(120);
    Servo5.write(160);
    Servo6.write(130);
    Servo7.write(90);
    Servo8.write(95);
    delay(Val1);
    restpos();
    }

    if (randNumber == 11){
    startup();
    //pinguin
    Servo3.write(70);
    Servo6.write(80);
    delay(Val4);
    Servo1.write(135);
    Servo2.write(20);
    Servo3.write(70);
    Servo4.write(50);
    Servo5.write(155);
    Servo6.write(80);
    Servo7.write(90);
    Servo8.write(70);
    delay(Val3);
    Servo2.write(110);
    Servo5.write(60);
    Servo8.write(95);
    delay(Val3);
    Servo2.write(20);
    Servo5.write(155);
    Servo8.write(70);
    delay(Val3);
    Servo2.write(110);
    Servo5.write(60);
    Servo8.write(95);
    delay(Val3);
    Servo2.write(20);
    Servo5.write(155);
    Servo8.write(70);
    delay(Val3);
    Servo2.write(110);
    Servo5.write(60);
    Servo8.write(95);
    delay(Val3);
    Servo2.write(20);
    Servo5.write(155);
    Servo8.write(70);
    delay(Val2);
    restpos();
    }

    if (randNumber == 12){
    startup();
    //ground controller
    Servo3.write(70);
    Servo6.write(80);
    delay(Val4);
    Servo1.write(135);
    Servo2.write(25);
    Servo4.write(50);
    Servo5.write(155);
    Servo7.write(90);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo3.write(165);
    Servo6.write(0);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo3.write(70);
    Servo6.write(80);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo3.write(165);
    Servo6.write(0);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val5);
    Servo3.write(70);
    Servo6.write(80);
    Servo8.write(70);
    delay(Val5);
    Servo8.write(95);
    delay(Val3);
    Servo1.write(135);
    Servo2.write(110);
    Servo3.write(70);
    Servo4.write(50);
    Servo5.write(60);
    Servo6.write(80);
    Servo7.write(90);
    delay(Val5);
    Servo3.write(130);
    Servo6.write(25);
    delay(Val3);
    Servo2.write(0);
    Servo5.write(180);
    delay(Val1);
    restpos();
    }
    
  }
}
  

/*
  Serial.print(Counter);
  Serial.print("        ");
  Serial.println(OldValue);
*/

}

void restpos(){
   // rest position
   Servo1.write(70);
   Servo2.write(70);
   Servo3.write(1);
   Servo4.write(110);
   Servo5.write(105);
   Servo6.write(175);
   Servo7.write(90);
   Servo8.write(95);
   digitalWrite(LED, LOW);
}

void startup(){
   digitalWrite(Relay, HIGH);
   delay(Val6);
   digitalWrite(Relay, LOW);
   delay(Val3);
   digitalWrite(LED, HIGH);
   delay(Val3);
   Servo1.write(70);
   Servo2.write(70);
   Servo3.write(1);
   Servo4.write(110);
   Servo5.write(105);
   Servo6.write(175);
   Servo7.write(90);
   Servo8.write(80);
   delay(Val3);
  
}




